Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Manipulator/UniformMutation.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Manipulator/UniformMutation.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Manipulator/UniformMutation.cs	(revision 15334)
@@ -1,3 +1,4 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Manipulator {
+﻿// ReSharper disable CompareOfFloatsByEqualityOperator
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Manipulator {
 
   using HeuristicLab.Common;
@@ -9,6 +10,8 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
 
@@ -27,7 +30,9 @@
       Parameters.Add(new ValueLookupParameter<PercentValue>("InInstructionProbability", "The probability of IN Instructions"));
 
-      Parameters.Add(new FixedValueParameter<PercentValue>("InstructionMutationProbability", "The probability an instruction gets mutated", new PercentValue(0.02)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("CloseMutationProbability", "The probability close gets mutated", new PercentValue(0.02)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("CloseIncrementRate", "When mutating individual, the increment rate specifies if close should be increased or decreased by 1.", new PercentValue(0.5)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("InstructionMutationProbability", "The probability instructions get mutated", new PercentValue(0.8)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("InstructionMutationRate", "The probability an instruction gets mutated", new PercentValue(0.01)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("InstructionConstantTweakRate", "When mutating an instruction, this parameter specifies if mutation is related to the current type (e.g. INTEGER, FLOAT) or not. ", new PercentValue(0)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("CloseMutationProbability", "The probability close gets mutated", new PercentValue(0.2)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("CloseIncrementRate", "When mutating individual, the increment rate specifies if close should be increased or decreased by 1.", new PercentValue(0.1)));
     }
 
@@ -47,4 +52,26 @@
       get { return InstructionMutationProbabilityParameter.Value.Value; }
       set { InstructionMutationProbabilityParameter.Value.Value = value; }
+    }
+
+    public IValueParameter<PercentValue> InstructionMutationRateParameter
+    {
+      get { return (IValueParameter<PercentValue>)Parameters["InstructionMutationRate"]; }
+    }
+
+    public double InstructionMutationRate
+    {
+      get { return InstructionMutationRateParameter.Value.Value; }
+      set { InstructionMutationRateParameter.Value.Value = value; }
+    }
+
+    public IValueParameter<PercentValue> InstructionConstantTweakRateParameter
+    {
+      get { return (IValueParameter<PercentValue>)Parameters["InstructionConstantTweakRate"]; }
+    }
+
+    public double InstructionConstantTweakRate
+    {
+      get { return InstructionConstantTweakRateParameter.Value.Value; }
+      set { InstructionConstantTweakRateParameter.Value.Value = value; }
     }
 
@@ -104,10 +131,12 @@
         RandomParameter.ActualValue,
         PlushVectorParameter.ActualValue,
-        CloseIncrementRate,
         ErcOptionsParameter.ActualValue,
         InstructionsParameter.ActualValue,
         InInstructionProbabilityParameter.ActualValue.Value,
         CloseMutationProbability,
-        InstructionMutationProbability);
+        CloseIncrementRate,
+        InstructionMutationProbability,
+        InstructionMutationRate,
+        InstructionConstantTweakRate);
       return base.InstrumentedApply();
     }
@@ -116,38 +145,72 @@
       IRandom random,
       PlushVector plushVector,
-      double closeIncrementRate,
       IReadOnlyErcOptions ercOptions,
       IReadOnlyExpressionsConfiguration instructions,
       double inInstructionProbability,
       double closeMutationProbability,
-      double instructionMutationProbability
+      double closeIncrementRate,
+      double instructionMutationProbability,
+      double instructionMutationRate,
+      double constantTweakRate
       ) {
 
-      for (var i = 0; i < plushVector.Entries.Count; i++) {
-        var entry = plushVector[i];
-        var x = random.NextDouble();
-
-        if (x < instructionMutationProbability) {
-          var instruction = CodeGeneratorUtils.GetRandomExpression(
-            random,
-            ercOptions,
-            instructions,
-            inInstructionProbability);
-          entry.Instruction = instruction;
+      var x = random.NextDouble();
+
+      // instruction manipulation
+      if (x < instructionMutationProbability) {
+        if (instructionMutationRate == 0) return;
+        for (var i = 0; i < plushVector.Entries.Count; i++) {
+          MutateInstruction(random, ercOptions, instructions, inInstructionProbability, instructionMutationRate, constantTweakRate, plushVector[i]);
         }
 
-        x = random.NextDouble();
-
-        if (x < closeMutationProbability) {
-          x = random.NextDouble();
-          entry.Close += x < closeIncrementRate ? 1 : -1;
-
-          if (entry.Close < 0)
-            entry.Close = 0;
+        plushVector.UpdatePushProgram();
+        return;
+      }
+
+      // close manipulation
+      if (x < instructionMutationProbability + closeMutationProbability) {
+        if (closeIncrementRate == 0) return;
+        for (var i = 0; i < plushVector.Entries.Count; i++) {
+          MutateClose(random, closeIncrementRate, plushVector[i]);
         }
+
+        plushVector.UpdatePushProgram();
+        return;
       }
-
-      // specifies that the program cached within entry must be updated before reuse
-      plushVector.UpdatePushProgram();
+    }
+
+    private static void MutateClose(IRandom random, double closeIncrementRate, PlushEntry entry) {
+      entry.Close += random.NextDouble() < closeIncrementRate ? 1 : -1;
+
+      if (entry.Close < 0)
+        entry.Close = 0;
+    }
+
+    private static void MutateInstruction(
+      IRandom random,
+      IReadOnlyErcOptions ercOptions,
+      IReadOnlyExpressionsConfiguration instructions,
+      double inInstructionProbability,
+      double instructionMutationRate,
+      double constantTweakRate,
+      PlushEntry entry) {
+
+      if (random.NextDouble() >= instructionMutationRate)
+        return;
+
+      var entryType = entry.Instruction.GetType();
+
+      if (constantTweakRate > 0 && random.NextDouble() < constantTweakRate &&
+          entryType.IsSubclass(typeof(PushExpression<>))) {
+        var attribute = ExpressionTable.TypeToAttributeTable[entryType];
+        entry.Instruction = CodeGeneratorUtils.CreateRandomErcExpression(attribute.StackType, random, ercOptions);
+        return;
+      }
+
+      entry.Instruction = CodeGeneratorUtils.GetRandomExpression(
+        random,
+        ercOptions,
+        instructions,
+        inInstructionProbability);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/IntegerVectorPushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/IntegerVectorPushBenchmarkSuiteProblem.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/IntegerVectorPushBenchmarkSuiteProblem.cs	(revision 15334)
@@ -51,5 +51,5 @@
       Description = data.Description;
       BestKnownQuality = data.BestResult;
-      Config.MaxPointsInProgram = data.MaxSize;
+      Config.MaxProgramLength = data.MaxSize;
       Config.EvalPushLimit = data.EvalLimit;
       Config.ErcOptions = data.ErcOptions;
@@ -62,5 +62,6 @@
       Encoding.Bounds[0, 1] = Config.EnabledExpressions.Count;
 
-      Encoding.Length = data.MaxSize;
+      Encoding.Length = data.MaxSize / 2;
+
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PlushPushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PlushPushBenchmarkSuiteProblem.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PlushPushBenchmarkSuiteProblem.cs	(revision 15334)
@@ -48,5 +48,5 @@
       Description = data.Description;
       BestKnownQuality = data.BestResult;
-      Config.MaxPointsInProgram = data.MaxSize;
+      Config.MaxProgramLength = data.MaxSize;
       Config.EvalPushLimit = data.EvalLimit;
       Config.ErcOptions = data.ErcOptions;
@@ -56,5 +56,6 @@
       Config.InitInExpressions(data.TotalInputArgumentCount);
 
-      Encoding.MaxLength = data.MaxSize;
+      Encoding.MinLength = 0;
+      Encoding.MaxLength = data.MaxSize / 2;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IntegerVectorPushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IntegerVectorPushProblem.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IntegerVectorPushProblem.cs	(revision 15334)
@@ -59,5 +59,5 @@
       Encoding.Bounds[0, 0] = 0;
       Encoding.Bounds[0, 1] = Config.EnabledExpressions.Count;
-      Encoding.Length = Config.MaxPointsInProgram;
+      Encoding.Length = Config.MaxProgramLength;
     }
 
@@ -72,7 +72,12 @@
 
       solutionCreator.ErcOptions = Config.ErcOptions;
+      solutionCreator.MinLength = Config.MinProgramLength;
 
       if (!Operators.OfType<PushExpressionFrequencyAnalyzer>().Any()) {
         Operators.Add(new PushExpressionFrequencyAnalyzer());
+      }
+
+      if (!Operators.OfType<IndividualZeroErrorAnalyzer>().Any()) {
+        Operators.Add(new IndividualZeroErrorAnalyzer());
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PlushPushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PlushPushProblem.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PlushPushProblem.cs	(revision 15334)
@@ -3,6 +3,4 @@
 
   using HeuristicLab.Common;
-  using HeuristicLab.Core;
-  using HeuristicLab.Data;
   using HeuristicLab.Optimization;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -31,5 +29,8 @@
       Encoding.ErcOptionsParameter = Config.ErcOptionsParameter;
       Encoding.InstructionsParameter = Config.InstructionsParameter;
-      Encoding.MaxLength = Config.MaxPointsInProgram;
+      Encoding.MinLengthParameter = Config.MinProgramLengthParameter;
+      Encoding.MaxLengthParameter = Config.MaxProgramLengthParameter;
+      Encoding.MaxCloseParameter = Config.MaxCloseParameter;
+      Encoding.CloseBiasLevelParameter = Config.CloseBiasLevelParameter;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15334)
@@ -0,0 +1,13 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem
+{
+    public class PushProblem
+    {
+        
+    }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblemBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblemBase.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblemBase.cs	(revision 15334)
@@ -20,5 +20,5 @@
   public abstract class PushProblemBase<T> : SingleObjectiveBasicProblem<T> where T : class, IEncoding {
     [Storable]
-    protected readonly PushConfigurationParameterCollection Config;
+    public readonly PushConfiguration Config;
 
     protected PushInterpreterPool Pool;
@@ -37,5 +37,5 @@
 
     protected PushProblemBase(IPushEvaluator evaluator) {
-      Config = new PushConfigurationParameterCollection();
+      Config = new PushConfiguration();
       PushEvaluator = evaluator;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs	(revision 15334)
@@ -10,5 +10,4 @@
     IValueLookupParameter<IntValue> MinLengthParameter { get; }
     IValueLookupParameter<IntValue> MaxLengthParameter { get; }
-    IValueLookupParameter<IntValue> MinCloseParameter { get; }
     IValueLookupParameter<IntValue> MaxCloseParameter { get; }
     IValueLookupParameter<DoubleValue> CloseBiasLevelParameter { get; }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PlushCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PlushCreator.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PlushCreator.cs	(revision 15334)
@@ -24,5 +24,4 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("MinLength", "The min length of the vector."));
       Parameters.Add(new ValueLookupParameter<IntValue>("MaxLength", "The max length of the vector."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("MinClose", "The min close variable for a plush genome entry."));
       Parameters.Add(new ValueLookupParameter<IntValue>("MaxClose", "The max close variable for a plush genome entry."));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("CloseBiasLevel", "Determines how strongly the random close variable is biased towards 0."));
@@ -69,8 +68,4 @@
       get { return (IValueLookupParameter<PercentValue>)Parameters["InInstructionProbability"]; }
     }
-    public IValueLookupParameter<IntValue> MinCloseParameter
-    {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MinClose"]; }
-    }
     public IValueLookupParameter<IntValue> MaxCloseParameter
     {
@@ -97,5 +92,4 @@
       var instructions = InstructionsParameter.ActualValue;
       var inInstructionProbability = InInstructionProbabilityParameter.ActualValue.Value;
-      var minClose = MinCloseParameter.ActualValue.Value;
       var maxClose = MaxCloseParameter.ActualValue.Value;
       var biasLevel = CloseBiasLevelParameter.ActualValue.Value;
@@ -103,7 +97,4 @@
       if (minLength > maxLength)
         throw new InvalidOperationException("MinLength > MaxLength");
-
-      if (minClose > maxClose)
-        throw new InvalidOperationException("MinClose > MaxClose");
 
       var length = random.Next(minLength, maxLength);
@@ -117,5 +108,5 @@
           inInstructionProbability);
 
-        var close = random.NextBiased(minClose, maxClose, biasLevel);
+        var close = maxClose == 0 ? 1 : random.NextBiased(0, maxClose, biasLevel);
 
         result.Add(new PlushEntry {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPrintStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPrintStack.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPrintStack.cs	(revision 15334)
@@ -1,4 +1,9 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Stack {
+  using System.Collections.Generic;
+
   public interface IPrintStack : IPushStack {
+    bool IsCurrentLineEmpty { get; }
+    IReadOnlyList<string> Lines { get; }
+
     void NewLine();
     void Push<T>(T item);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PrintStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PrintStack.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PrintStack.cs	(revision 15334)
@@ -14,9 +14,16 @@
   public class PrintStack : IPrintStack {
     private int lineCount = 0;
+    private int length = 0;
+    private IReadOnlyList<string> lines;
     private readonly StringBuilder stringBuilder = new StringBuilder();
 
+    public PrintStack() {
+      IsCurrentLineEmpty = true;
+    }
+
+    public bool IsCurrentLineEmpty { get; private set; }
+
     IEnumerator IEnumerable.GetEnumerator() {
-      var lines = AsStrings();
-      return lines.GetEnumerator();
+      return Lines.GetEnumerator();
     }
 
@@ -25,5 +32,21 @@
     }
 
+    public IReadOnlyList<string> Lines
+    {
+      get
+      {
+        if (stringBuilder.Length == length) return lines;
+        length = stringBuilder.Length;
+        lines = stringBuilder.ToString().Split(PushEnvironment.NewLine);
+
+        return lines;
+      }
+    }
+
     void IPushStack.Clear() {
+      lineCount = 0;
+      length = 0;
+      lines = null;
+      IsCurrentLineEmpty = true;
       stringBuilder.Clear();
     }
@@ -31,4 +54,5 @@
     public void NewLine() {
       stringBuilder.Append(PushEnvironment.NewLine);
+      IsCurrentLineEmpty = true;
       lineCount++;
     }
@@ -36,5 +60,7 @@
     public void Push<T>(T item) {
       if (IsEmpty) lineCount = 1;
-      stringBuilder.Append(item);
+      var str = item.ToString();
+      stringBuilder.Append(str);
+      IsCurrentLineEmpty = IsCurrentLineEmpty && string.IsNullOrEmpty(str);
     }
 
@@ -42,4 +68,5 @@
       if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
+      IsCurrentLineEmpty = false;
     }
 
@@ -47,4 +74,5 @@
       if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
+      IsCurrentLineEmpty = false;
     }
 
@@ -52,4 +80,5 @@
       if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
+      IsCurrentLineEmpty = false;
     }
 
@@ -57,4 +86,5 @@
       if (IsEmpty) lineCount = 1;
       stringBuilder.Concat(item);
+      IsCurrentLineEmpty = false;
     }
 
@@ -62,4 +92,5 @@
       if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
+      IsCurrentLineEmpty = false;
     }
 
@@ -67,10 +98,11 @@
       if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
+      IsCurrentLineEmpty = false;
     }
-
 
     public void Push(string item) {
       if (IsEmpty) lineCount = 1;
       stringBuilder.Append(item);
+      IsCurrentLineEmpty = IsCurrentLineEmpty && string.IsNullOrEmpty(item);
     }
 
@@ -78,4 +110,6 @@
       for (var i = startIndex; i < items.Count; i++)
         stringBuilder.Append(items[i]);
+
+      IsCurrentLineEmpty = false;
     }
 
@@ -87,13 +121,14 @@
       foreach (var item in items)
         stringBuilder.Append(item);
+
+      IsCurrentLineEmpty = false;
     }
 
     public IEnumerable<string> AsStrings() {
-      var lines = stringBuilder.ToString().Split(PushEnvironment.NewLine);
-      return lines;
+      return Lines;
     }
 
     public IEnumerable<object> AsObjects() {
-      return AsStrings();
+      return Lines;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/GPTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/GPTests.cs	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/GPTests.cs	(revision 15334)
@@ -0,0 +1,344 @@
+﻿using System.Linq;
+// ReSharper disable PossibleNullReferenceException
+
+namespace HeuristicLab.Tests.Benchmark {
+  using System;
+  using System.Threading;
+
+  using HeuristicLab.Algorithms.GeneticAlgorithm;
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Data;
+  using HeuristicLab.ParallelEngine;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Crossover;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Manipulator;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Selector;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class GpTests {
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void Checksum() {
+      Run<Checksum>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void CollatzNumbers() {
+      Run<CollatzNumbers>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void CompareStringLengths() {
+      Run<CompareStringLengths>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void CountOdds() {
+      Run<CountOdds>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void Digits() {
+      Run<Digits>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void DoubleLetters() {
+      Run<DoubleLetters>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void EvenSquares() {
+      Run<EvenSquares>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void ForLoopIndex() {
+      Run<ForLoopIndex>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void Grades() {
+      Run<Grades>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void LastIndexOfZero() {
+      Run<LastIndexOfZero>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void Median() {
+      Run<Median>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void MirrorImage() {
+      Run<MirrorImage>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void NegativeToZero() {
+      Run<NegativeToZero>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void NumberIo() {
+      Run<NumberIO>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void PigLatin() {
+      Run<PigLatin>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void ReplaceSpaceWithNewLine() {
+      Run<ReplaceSpaceWithNewline>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void ScrabbleScore() {
+      Run<ScrabbleScore>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void Smallest() {
+      Run<Smallest>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void SmallOrLarge() {
+      Run<SmallOrLarge>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void StringDifferences() {
+      Run<StringDifferences>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void StringLengthsBackwards() {
+      Run<StringLengthsBackwards>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void SumOfSquares() {
+      Run<SumOfSquares>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void SuperAnagrams() {
+      Run<SuperAnagrams>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void Syllables() {
+      Run<Syllables>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void VectorAverage() {
+      Run<VectorAverage>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void VectorSummed() {
+      Run<VectorSummed>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void WallisPi() {
+      Run<WallisPi>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void WordStats() {
+      Run<WordStats>();
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Long")]
+    [TestCategory("ProblemTest")]
+    public void XWordLines() {
+      Run<XWordLines>();
+    }
+
+    static void Run<T>() where T : IBenchmarkSuiteDataDescriptor, new() {
+      var trigger = new AutoResetEvent(false);
+      var alg = GetAlgorithm(new T());
+      Exception exception = null;
+
+      alg.ExceptionOccurred += (sender, args) => {
+        exception = args.Value;
+        trigger.Set();
+      };
+
+      alg.Stopped += (sender, args) => {
+        trigger.Set();
+      };
+
+      var lastGeneration = -1;
+      alg.ExecutionTimeChanged += (sender, args) => {
+        if (!alg.Results.Any() || !alg.Results.ContainsKey("CurrentBestQuality")) return;
+
+        var generation = (alg.Results["Generations"].Value as IntValue).Value;
+
+        if (lastGeneration != -1 && generation == lastGeneration) return;
+
+        Console.WriteLine(@"Generation: {0}", generation);
+
+        if (alg.Results.ContainsKey("CurrentBestQuality")) {
+          var best = (alg.Results["CurrentBestQuality"].Value as DoubleValue).Value;
+          Console.WriteLine(@"CurrentBestQuality: {0}", best);
+        }
+
+        if (alg.Results.ContainsKey("CurrentAverageQuality")) {
+          var average = (alg.Results["CurrentAverageQuality"].Value as DoubleValue).Value;
+          Console.WriteLine(@"CurrentAverageQuality: {0}", average);
+        }
+
+        if (alg.Results.ContainsKey("CurrentWorstQuality")) {
+          var worst = (alg.Results["CurrentWorstQuality"].Value as DoubleValue).Value;
+          Console.WriteLine(@"CurrentWorstQuality: {0}", worst);
+        }
+
+        Console.WriteLine();
+        lastGeneration = generation;
+      };
+
+      alg.Prepare();
+      alg.Start();
+      trigger.WaitOne();
+
+      if (exception != null) {
+        Console.WriteLine(exception.Message);
+        throw exception;
+      }
+
+      var finalGeneration = (alg.Results["Generations"].Value as IntValue).Value;
+      var bestQuality = (alg.Results["CurrentBestQuality"].Value as DoubleValue).Value;
+      var averageQuality = (alg.Results["CurrentAverageQuality"].Value as DoubleValue).Value;
+      var worstQuality = (alg.Results["CurrentWorstQuality"].Value as DoubleValue).Value;
+
+      Console.WriteLine(@"Final Generation: {0}", finalGeneration);
+      Console.WriteLine(@"CurrentBestQuality: {0}", bestQuality);
+      Console.WriteLine(@"CurrentAverageQuality: {0}", averageQuality);
+      Console.WriteLine(@"CurrentWorstQuality: {0}", worstQuality);
+    }
+
+    static GeneticAlgorithm GetAlgorithm(IBenchmarkSuiteDataDescriptor descriptor) {
+      var ga = new GeneticAlgorithm();
+
+      var problemData = descriptor.CreateProblemData();
+      var pushProblem = new PlushPushBenchmarkSuiteProblem();
+
+      pushProblem.Load(problemData);
+      ga.Name = "GA " + pushProblem.Name;
+
+      ga.Problem = pushProblem;
+
+      var crossover = ga.CrossoverParameter.ValidValues.OfType<AlternationCrossover>().First();
+
+      switch (problemData.ProblemType) {
+        case ProblemType.NumberIO:
+        case ProblemType.SmallOrLarge:
+        case ProblemType.Median:
+        case ProblemType.Smallest:
+          crossover.AlignmentDeviation = 5;
+          break;
+
+        default:
+          crossover.AlignmentDeviation = 10;
+          break;
+      }
+
+      crossover.AlternationRate = 0.01;
+      ga.Crossover = crossover;
+
+      ga.Selector = ga.SelectorParameter.ValidValues.OfType<LexicaseSelector>().First();
+
+      var mutator = ga.MutatorParameter.ValidValues.OfType<UniformMutation>().First();
+      mutator.InstructionMutationProbability = 0.875;
+      mutator.CloseMutationProbability = 0.125;
+      mutator.CloseIncrementRate = 0.1;
+      ga.Mutator = mutator;
+
+      ga.MutationProbability.Value = 0.8;
+      ga.SetSeedRandomly.Value = true;
+      ga.PopulationSize.Value = 1000;
+
+      ga.MaximumGenerations.Value = 9; // problemData.ProgramExecutionBudget / problemData.TrainingCount / 1000;
+
+      // remove unnecessary analyzers to improve performance
+      pushProblem.OperatorsParameter.Value
+        .RemoveAll(analyzer =>
+          analyzer.GetType() == typeof(IndividualZeroErrorAnalyzer) ||
+          analyzer.GetType() == typeof(PushExpressionFrequencyAnalyzer));
+
+      ga.Engine = new ParallelEngine();
+
+      return ga;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs	(revision 15334)
@@ -24,5 +24,5 @@
       var config = new PushConfiguration {
         EvalPushLimit = data.EvalLimit,
-        MaxPointsInProgram = data.MaxSize,
+        MaxProgramLength = data.MaxSize,
         ErcOptions = data.ErcOptions,
       };
